/*
   +----------------------------------------------------------------------+
   | PHP Version 4                                                        |
   +----------------------------------------------------------------------+
   | Copyright (c) 1997-2003 The PHP Group                                |
   +----------------------------------------------------------------------+
   | This source file is subject to version 2.02 of the PHP license,      |
   | that is bundled with this package in the file LICENSE, and is        |
   | available at through the world-wide-web at                           |
   | http://www.php.net/license/2_02.txt.                                 |
   | If you did not receive a copy of the PHP license and are unable to   |
   | obtain it through the world-wide-web, please send a note to          |
   | license@php.net so we can mail you a copy immediately.               |
   +----------------------------------------------------------------------+
   | Author: David Eder <david@eder.us>                                   |
   +----------------------------------------------------------------------+
*/

#ifndef _PHP_ASTERISK_H_
#define _PHP_ASTERISK_H_

#ifndef _REENTRANT
#define _REENTRANT
#endif

#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif

#include <main/php.h>
#include <main/SAPI.h>
#include <main/php_main.h>
#include <main/php_variables.h>
#include <main/php_ini.h>
#include <zend_ini.h>

#include <asterisk/file.h>
#include <asterisk/logger.h>
#include <asterisk/channel.h>
#include <asterisk/pbx.h>
#include <asterisk/module.h>
#include <asterisk/astdb.h>
#include <asterisk/cli.h>
#include <asterisk/logger.h>
#include <asterisk/options.h>
#include <asterisk/image.h>
#include <asterisk/say.h>
#include <asterisk/app.h>
#include <asterisk/dsp.h>
#include <asterisk/musiconhold.h>
#include <asterisk/ast_expr.h>
#include <asterisk/callerid.h>
#include <asterisk/cdr.h>
#include <asterisk/channel.h>
#include <asterisk/channel_pvt.h>
#include <asterisk/cli.h>
#include <asterisk/config.h>
#include <asterisk/config_pvt.h>
#include <asterisk/file.h>
#include <asterisk/linkedlists.h>
#include <asterisk/lock.h>
#include <asterisk/logger.h>
#include <asterisk/manager.h>
#include <asterisk/md5.h>
#include <asterisk/module.h>
#include <asterisk/options.h>
#include <asterisk/pbx.h>
#include <asterisk/utils.h>
#include <asterisk/say.h>
#include <asterisk/term.h>
#include <asterisk/features.h>

#include <string.h>
#include <stdlib.h>

#ifdef PHP_WIN32
#include <io.h>
#include <fcntl.h>
#endif

#ifdef ZTS
#define PTSRMLS_D        void ****ptsrm_ls
#define PTSRMLS_DC       , PTSRMLS_D
#define PTSRMLS_C        &tsrm_ls
#define PTSRMLS_CC       , PTSRMLS_C
#else
#define PTSRMLS_D
#define PTSRMLS_DC
#define PTSRMLS_C
#define PTSRMLS_CC
#endif

#define PHP_ASTERISK_START_BLOCK(x,y) { \
    void ***tsrm_ls; \
    php_asterisk_init(x, y PTSRMLS_CC); \
    zend_first_try {

#define PHP_ASTERISK_END_BLOCK() \
  } zend_catch { \
    /* int exit_status = EG(exit_status); */ \
  } zend_end_try(); \
  php_asterisk_shutdown(TSRMLS_C); \
}

BEGIN_EXTERN_C() 
int php_asterisk_init(int argc, char **argv PTSRMLS_DC);
void php_asterisk_shutdown(TSRMLS_D);
extern sapi_module_struct php_asterisk_module;
END_EXTERN_C()


#endif /* _PHP_ASTERISK_H_ */
